document.addEventListener('DOMContentLoaded', function() {
    var modal = document.getElementById('modal');
    var modalImg = document.getElementById("modal-image");
    var closeBtn = document.getElementsByClassName("close")[0];
    var prevBtn = document.getElementsByClassName("prev")[0];
    var nextBtn = document.getElementsByClassName("next")[0];
    var images = document.getElementsByClassName('gallery-image');
    var currentIndex = 0;

    Array.from(images).forEach(function(img, index) {
        img.onclick = function() {
            modal.classList.add('show');
            modalImg.src = this.getAttribute('data-fullsize');
            currentIndex = index;
        }
    });

    closeBtn.onclick = function() {
        modal.classList.remove('show');
    }

    window.onclick = function(event) {
        if (event.target == modal) {
            modal.classList.remove('show');
        }
    }

    prevBtn.onclick = function() {
        currentIndex = (currentIndex - 1 + images.length) % images.length;
        modalImg.src = images[currentIndex].getAttribute('data-fullsize');
    }

    nextBtn.onclick = function() {
        currentIndex = (currentIndex + 1) % images.length;
        modalImg.src = images[currentIndex].getAttribute('data-fullsize');
    }

    document.onkeydown = function(e) {
        if (e.key === "Escape") {
            modal.classList.remove('show');
        } else if (e.key === "ArrowLeft") {
            prevBtn.click();
        } else if (e.key === "ArrowRight") {
            nextBtn.click();
        }
    }
});
