<?php
$pageTitle = "Download-Bereich";
$currentPage = "downloads";
include 'code/header.php';
?>

<main>
    <?php
    $baseDir = 'downloads';
    $currentDir = isset($_GET['dir']) ? $_GET['dir'] : $baseDir;
    $relativePath = str_replace($baseDir, '', $currentDir);
    $pathParts = explode('/', trim($relativePath, '/'));

    echo "<div class='navigation'>";
    if ($currentDir != $baseDir) {
        $parentDir = dirname($currentDir);
        echo "<a href='?dir=" . htmlspecialchars($parentDir) . "' class='back-button'>Zur&uuml;ck</a>";
    }

    echo "<div class='path'>";
    echo "<a href='?dir=" . htmlspecialchars($baseDir) . "'>Home</a> / ";
    $currentPath = $baseDir;
    foreach ($pathParts as $part) {
        if (!empty($part)) {
            $currentPath .= "/$part";
            echo "<a href='?dir=" . htmlspecialchars($currentPath) . "'>" . htmlspecialchars($part) . "</a> / ";
        }
    }
    echo "</div>";
    echo "</div>";
    ?>
    <div id="downloads">
        <?php
        $directories = [];
        $files = [];

        foreach (scandir($currentDir) as $item) {
            if ($item == '.' || $item == '..') continue;
            $path = $currentDir . '/' . $item;
            if (is_dir($path)) {
                $directories[] = $item;
            } else {
                $files[] = $item;
            }
        }

        // Display directories and files in a table
        echo "<table class='file-table'>";
        echo "<thead><tr><th>Dateiname</th><th>Typ</th><th>Gre</th><th>Erstellungsdatum</th></tr></thead>";
        echo "<tbody>";

        // Display directories
        foreach ($directories as $dir) {
            $dirPath = $currentDir . '/' . $dir;
            echo "<tr>";
            echo "<td><span class='icon icon-folder'></span> <a href='?dir=" . htmlspecialchars($dirPath) . "'>" . htmlspecialchars($dir) . "</a></td>";
            echo "<td>Ordner</td>";
            echo "<td>-</td>";
            echo "<td>" . date("d.m.Y H:i:s", filectime($dirPath)) . "</td>";
            echo "</tr>";
        }

        // Display files
        foreach ($files as $file) {
            $filePath = $currentDir . '/' . $file;
            $fileSize = filesize($filePath);
            $fileSizeMB = round($fileSize / (1024 * 1024), 2);
            $fileType = pathinfo($filePath, PATHINFO_EXTENSION);
            echo "<tr>";
            echo "<td><span class='icon icon-file'></span> <a href='" . htmlspecialchars($filePath) . "' download>" . htmlspecialchars($file) . "</a></td>";
            echo "<td>" . strtoupper($fileType) . "</td>";
            echo "<td>" . $fileSizeMB . " MB</td>";
            echo "<td>" . date("d.m.Y H:i:s", filectime($filePath)) . "</td>";
            echo "</tr>";
        }

        echo "</tbody>";
        echo "</table>";
        ?>
    </div>
</main>

<?php include 'code/footer.php'; ?>
