<?php
$pageTitle = "Bilder-Galerie";
$currentPage = "gallery";
include 'code/header.php';
?>

<main>
    <?php
    $baseDir = 'images';
    $currentDir = isset($_GET['dir']) ? $_GET['dir'] : $baseDir;
    $relativePath = str_replace($baseDir, '', $currentDir);
    $pathParts = explode('/', trim($relativePath, '/'));

    echo "<div class='navigation'>";
    if ($currentDir != $baseDir) {
        $parentDir = dirname($currentDir);
        echo "<a href='?dir=" . htmlspecialchars($parentDir) . "' class='back-button'>Zur&uuml;ck</a>";
    }

    echo "<div class='path'>";
    echo "<a href='?dir=" . htmlspecialchars($baseDir) . "'>Home</a> / ";
    $currentPath = $baseDir;
    foreach ($pathParts as $part) {
        if (!empty($part)) {
            $currentPath .= "/$part";
            echo "<a href='?dir=" . htmlspecialchars($currentPath) . "'>" . htmlspecialchars($part) . "</a> / ";
        }
    }
    echo "</div>";
    echo "</div>";
    ?>
    <div id="gallery" class="gallery-container">
        <?php
        function createThumbnail($src, $dest, $targetSize) {
            $info = getimagesize($src);
            $width = $info[0];
            $height = $info[1];

            switch ($info[2]) {
                case IMAGETYPE_GIF:  $image = imagecreatefromgif($src);  break;
                case IMAGETYPE_JPEG: $image = imagecreatefromjpeg($src); break;
                case IMAGETYPE_PNG:  $image = imagecreatefrompng($src);  break;
                default: return false;
            }

            $thumb = imagecreatetruecolor($targetSize, $targetSize);
            $background = imagecolorallocate($thumb, 255, 255, 255);
            imagefill($thumb, 0, 0, $background);

            $aspectRatio = $width / $height;
            if ($aspectRatio > 1) {
                $newWidth = $targetSize;
                $newHeight = $targetSize / $aspectRatio;
            } else {
                $newHeight = $targetSize;
                $newWidth = $targetSize * $aspectRatio;
            }

            $xOffset = ($targetSize - $newWidth) / 2;
            $yOffset = ($targetSize - $newHeight) / 2;

            imagecopyresampled($thumb, $image, $xOffset, $yOffset, 0, 0, $newWidth, $newHeight, $width, $height);

            switch ($info[2]) {
                case IMAGETYPE_GIF:  imagegif($thumb, $dest);  break;
                case IMAGETYPE_JPEG: imagejpeg($thumb, $dest); break;
                case IMAGETYPE_PNG:  imagepng($thumb, $dest);  break;
                default: return false;
            }

            return true;
        }

        $directories = [];
        $images = [];

        foreach (scandir($currentDir) as $item) {
            if ($item == '.' || $item == '..') continue;
            $path = $currentDir . '/' . $item;
            if (is_dir($path)) {
                $directories[] = $item;
            } elseif (in_array(strtolower(pathinfo($item, PATHINFO_EXTENSION)), ['jpg', 'jpeg', 'png', 'gif'])) {
                $images[] = $item;
            }
        }

        // Display directories
        foreach ($directories as $dir) {
            $dirPath = $currentDir . '/' . $dir;
            echo "<div class='folder-container'>";
            echo "<a href='?dir=" . htmlspecialchars($dirPath) . "' class='folder-link'>";
            echo "<div class='folder-icon'><span class='icon icon-folder'></span></div>";
            echo htmlspecialchars($dir);
            echo "</a>";
            echo "</div>";
        }

        // Display images
        foreach ($images as $image) {
            $imagePath = $currentDir . '/' . $image;
            $thumbPath = 'thumbnails/' . md5($imagePath) . '.jpg';
            if (!file_exists($thumbPath)) {
                if (!file_exists('thumbnails')) {
                    mkdir('thumbnails', 0777, true);
                }
                createThumbnail($imagePath, $thumbPath, 300);
            }
            echo "<div class='image-container'>";
            echo "<img src='" . htmlspecialchars($thumbPath) . "' alt='" . htmlspecialchars($image) . "' class='gallery-image' data-fullsize='" . htmlspecialchars($imagePath) . "'>";
            echo "</div>";
        }
        ?>
    </div>
    <div id="modal" class="modal">
        <span class="close">&times;</span>
        <img class="modal-content" id="modal-image">
        <a class="prev">&#10094;</a>
        <a class="next">&#10095;</a>
    </div>
</main>

<script src="code/script.js"></script>
<?php include 'code/footer.php'; ?>
